/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __oplab_ImportOp_h__
#define __oplab_ImportOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Load a text file as a joint transforms

	@ingroup oplab
*//***************************************************************************/
class FE_DL_EXPORT ImportOp:
	public OperatorSurfaceCommon,
	public Initialize<ImportOp>
{
	public:

					ImportOp(void)											{}
virtual				~ImportOp(void)											{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

	private:
		sp<Scope>				m_spScope;

		sp<SurfaceAccessibleI>	m_spLoadAccessible;
		String					m_loadedFile;
		String					m_loadedFormat;

};

} /* namespace */

#endif /* __oplab_ImportOp_h__ */
