/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __oplab_PuppetOp_h__
#define __oplab_PuppetOp_h__

namespace fe
{

/**************************************************************************//**
	@brief manipulate joint transforms

	@ingroup oplab
*//***************************************************************************/
class FE_DL_EXPORT PuppetOp:
	public OperatorState,
	public Initialize<PuppetOp>
{
	public:

						PuppetOp(void):
							m_brushed(FALSE),
							m_dragging(FALSE)								{}

virtual					~PuppetOp(void)										{}

		void			initialize(void);

						//* As HandlerI
virtual	void			handle(Record& a_rSignal);

	protected:

virtual	void			setupState(void);
virtual	BWORD			loadState(const String& a_rBuffer);

	private:

		Record			lookupJoint(String a_jointName);

		sp<SurfaceAccessibleI>				m_spOutputAccessible;

		sp<DrawMode>						m_spWireframe;
		sp<DrawMode>						m_spSolid;

		BWORD								m_brushed;
		WindowEvent							m_event;
		BWORD								m_dragging;
		I32									m_lastX;
		I32									m_lastY;

		String								m_pickName;

		std::map<String,SpatialTransform>	m_animMap;
		std::map<String,I32>				m_posePrimitiveMap;
		std::map<String,I32>				m_offsetPrimitiveMap;

		sp< RecordMap<String> >				m_spJointMap;
		Accessor<String>					m_aName;
		Accessor<Real>						m_aFreedom;

};

} /* namespace */

#endif /* __oplab_PuppetOp_h__ */
